Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 1 | # |
Marcin Wojtas | a86fe0c | 2020-06-02 15:12:06 +0200 | [diff] [blame] | 2 | # Copyright (C) 2016 - 2020 Marvell International Ltd. |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 3 | # |
| 4 | # SPDX-License-Identifier: BSD-3-Clause |
| 5 | # https://spdx.org/licenses |
| 6 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 7 | PLAT_FAMILY := a8k |
Grzegorz Jaszczyk | 3039bce | 2019-11-05 13:14:59 +0100 | [diff] [blame] | 8 | PLAT_INCLUDE_BASE := include/plat/marvell/armada/$(PLAT_FAMILY) |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 9 | PLAT_COMMON_BASE := plat/marvell/armada/a8k/common |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 10 | MARVELL_DRV_BASE := drivers/marvell |
Grzegorz Jaszczyk | 3039bce | 2019-11-05 13:14:59 +0100 | [diff] [blame] | 11 | MARVELL_COMMON_BASE := plat/marvell/armada/common |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 12 | |
Konstantin Porotchkin | 2309961 | 2020-10-12 18:13:07 +0300 | [diff] [blame] | 13 | MARVELL_SVC_TEST := 0 |
Konstantin Porotchkin | f51f251 | 2018-11-06 12:25:38 +0200 | [diff] [blame] | 14 | $(eval $(call add_define,MARVELL_SVC_TEST)) |
| 15 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 16 | ERRATA_A72_859971 := 1 |
| 17 | |
| 18 | # Enable MSS support for a8k family |
| 19 | MSS_SUPPORT := 1 |
Konstantin Porotchkin | 2309961 | 2020-10-12 18:13:07 +0300 | [diff] [blame] | 20 | $(eval $(call add_define,MSS_SUPPORT)) |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 21 | |
| 22 | # Disable EL3 cache for power management |
Marcin Wojtas | a86fe0c | 2020-06-02 15:12:06 +0200 | [diff] [blame] | 23 | BL31_CACHE_DISABLE := 0 |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 24 | $(eval $(call add_define,BL31_CACHE_DISABLE)) |
| 25 | |
| 26 | $(eval $(call add_define,PCI_EP_SUPPORT)) |
| 27 | $(eval $(call assert_boolean,PCI_EP_SUPPORT)) |
| 28 | |
Grzegorz Jaszczyk | 2ed16f5 | 2018-06-29 18:00:33 +0200 | [diff] [blame] | 29 | AP_NUM := 1 |
| 30 | $(eval $(call add_define,AP_NUM)) |
| 31 | |
Konstantin Porotchkin | 6ff50d5 | 2018-10-07 17:54:20 +0300 | [diff] [blame] | 32 | DOIMAGEPATH ?= tools/marvell/doimage |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 33 | DOIMAGETOOL ?= ${DOIMAGEPATH}/doimage |
| 34 | |
Pali Rohár | 85e0a89 | 2020-10-19 17:10:11 +0200 | [diff] [blame] | 35 | include plat/marvell/marvell.mk |
Pali Rohár | 6dca2c6 | 2020-10-21 11:50:40 +0200 | [diff] [blame] | 36 | include tools/marvell/doimage/doimage.mk |
| 37 | |
| 38 | ifeq (${MARVELL_SECURE_BOOT},1) |
| 39 | DOIMAGE_SEC_FLAGS := -c $(DOIMAGE_SEC) |
| 40 | DOIMAGE_LIBS_CHECK = \ |
| 41 | if ! [ -d "/usr/include/mbedtls" ]; then \ |
| 42 | echo "****************************************" >&2; \ |
| 43 | echo "Missing mbedTLS installation! " >&2; \ |
| 44 | echo "Please download it from \"tls.mbed.org\"" >&2; \ |
| 45 | echo "Alternatively on Debian/Ubuntu system install" >&2; \ |
| 46 | echo "\"libmbedtls-dev\" package" >&2; \ |
| 47 | echo "Make sure to use version 2.1.0 or later" >&2; \ |
| 48 | echo "****************************************" >&2; \ |
| 49 | exit 1; \ |
| 50 | else if ! [ -f "/usr/include/libconfig.h" ]; then \ |
| 51 | echo "********************************************************" >&2; \ |
| 52 | echo "Missing Libconfig installation!" >&2; \ |
| 53 | echo "Please download it from \"www.hyperrealm.com/libconfig/\"" >&2; \ |
| 54 | echo "Alternatively on Debian/Ubuntu system install packages" >&2; \ |
| 55 | echo "\"libconfig8\" and \"libconfig8-dev\"" >&2; \ |
| 56 | echo "********************************************************" >&2; \ |
| 57 | exit 1; \ |
| 58 | fi \ |
| 59 | fi |
| 60 | else #MARVELL_SECURE_BOOT |
| 61 | DOIMAGE_LIBS_CHECK = |
| 62 | DOIMAGE_SEC_FLAGS = |
| 63 | endif #MARVELL_SECURE_BOOT |
Pali Rohár | 85e0a89 | 2020-10-19 17:10:11 +0200 | [diff] [blame] | 64 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 65 | ROM_BIN_EXT ?= $(BUILD_PLAT)/ble.bin |
| 66 | DOIMAGE_FLAGS += -b $(ROM_BIN_EXT) $(NAND_DOIMAGE_FLAGS) $(DOIMAGE_SEC_FLAGS) |
| 67 | |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 68 | # Check whether to build system_power.c for the platform |
Luka Kovacic | 7a75c06 | 2020-07-03 17:02:54 +0200 | [diff] [blame] | 69 | ifneq ("$(wildcard $(BOARD_DIR)/board/system_power.c)","") |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 70 | SYSTEM_POWER_SUPPORT = 1 |
| 71 | else |
| 72 | SYSTEM_POWER_SUPPORT = 0 |
| 73 | endif |
| 74 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 75 | # This define specifies DDR type for BLE |
| 76 | $(eval $(call add_define,CONFIG_DDR4)) |
| 77 | |
| 78 | MARVELL_GIC_SOURCES := drivers/arm/gic/common/gic_common.c \ |
| 79 | drivers/arm/gic/v2/gicv2_main.c \ |
| 80 | drivers/arm/gic/v2/gicv2_helpers.c \ |
| 81 | plat/common/plat_gicv2.c |
| 82 | |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 83 | PLAT_INCLUDES := -I$(BOARD_DIR) \ |
Grzegorz Jaszczyk | d3d6a1c | 2019-03-28 16:09:38 +0100 | [diff] [blame] | 84 | -I$(BOARD_DIR)/board \ |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 85 | -I$(PLAT_COMMON_BASE)/include \ |
Antonio Nino Diaz | 50a4d1a | 2019-02-01 12:22:22 +0000 | [diff] [blame] | 86 | -I$(PLAT_INCLUDE_BASE)/common |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 87 | |
| 88 | PLAT_BL_COMMON_SOURCES := $(PLAT_COMMON_BASE)/aarch64/a8k_common.c \ |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 89 | drivers/ti/uart/aarch64/16550_console.S |
| 90 | |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 91 | BLE_PORTING_SOURCES := $(BOARD_DIR)/board/dram_port.c \ |
| 92 | $(BOARD_DIR)/board/marvell_plat_config.c |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 93 | |
| 94 | MARVELL_MOCHI_DRV += $(MARVELL_DRV_BASE)/mochi/cp110_setup.c |
| 95 | |
Christine Gharzuzi | 9a772df | 2018-06-25 13:39:37 +0300 | [diff] [blame] | 96 | BLE_SOURCES := drivers/mentor/i2c/mi2cv.c \ |
| 97 | $(PLAT_COMMON_BASE)/plat_ble_setup.c \ |
| 98 | $(MARVELL_MOCHI_DRV) \ |
| 99 | $(PLAT_COMMON_BASE)/plat_pm.c \ |
| 100 | $(MARVELL_DRV_BASE)/ap807_clocks_init.c \ |
| 101 | $(MARVELL_DRV_BASE)/thermal.c \ |
| 102 | $(PLAT_COMMON_BASE)/plat_thermal.c \ |
| 103 | $(BLE_PORTING_SOURCES) \ |
| 104 | $(MARVELL_DRV_BASE)/ccu.c \ |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 105 | $(MARVELL_DRV_BASE)/io_win.c |
| 106 | |
| 107 | BL1_SOURCES += $(PLAT_COMMON_BASE)/aarch64/plat_helpers.S \ |
| 108 | lib/cpus/aarch64/cortex_a72.S |
| 109 | |
| 110 | MARVELL_DRV := $(MARVELL_DRV_BASE)/io_win.c \ |
| 111 | $(MARVELL_DRV_BASE)/iob.c \ |
| 112 | $(MARVELL_DRV_BASE)/mci.c \ |
| 113 | $(MARVELL_DRV_BASE)/amb_adec.c \ |
| 114 | $(MARVELL_DRV_BASE)/ccu.c \ |
| 115 | $(MARVELL_DRV_BASE)/cache_llc.c \ |
Grzegorz Jaszczyk | a3173d6 | 2019-12-18 15:58:27 +0100 | [diff] [blame] | 116 | $(MARVELL_DRV_BASE)/comphy/phy-comphy-cp110.c \ |
| 117 | $(MARVELL_DRV_BASE)/mc_trustzone/mc_trustzone.c \ |
Alex Leibovich | 6a99b19 | 2019-12-25 09:22:48 +0200 | [diff] [blame] | 118 | $(MARVELL_DRV_BASE)/secure_dfx_access/armada_thermal.c \ |
Grzegorz Jaszczyk | 7d50972 | 2020-01-03 09:35:21 +0100 | [diff] [blame] | 119 | $(MARVELL_DRV_BASE)/secure_dfx_access/misc_dfx.c \ |
Alex Leibovich | 6a99b19 | 2019-12-25 09:22:48 +0200 | [diff] [blame] | 120 | $(MARVELL_DRV_BASE)/ddr_phy_access.c \ |
Konstantin Porotchkin | 7b9e4d4 | 2020-07-26 17:49:54 +0300 | [diff] [blame] | 121 | drivers/rambus/trng_ip_76.c |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 122 | |
Konstantin Porotchkin | 2309961 | 2020-10-12 18:13:07 +0300 | [diff] [blame] | 123 | ifeq (${MSS_SUPPORT}, 1) |
| 124 | MARVELL_DRV += $(MARVELL_DRV_BASE)/mg_conf_cm3/mg_conf_cm3.c |
| 125 | endif |
| 126 | |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 127 | BL31_PORTING_SOURCES := $(BOARD_DIR)/board/marvell_plat_config.c |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 128 | |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 129 | ifeq ($(SYSTEM_POWER_SUPPORT),1) |
Luka Kovacic | 7a75c06 | 2020-07-03 17:02:54 +0200 | [diff] [blame] | 130 | BL31_PORTING_SOURCES += $(BOARD_DIR)/board/system_power.c |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 131 | endif |
| 132 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 133 | BL31_SOURCES += lib/cpus/aarch64/cortex_a72.S \ |
| 134 | $(PLAT_COMMON_BASE)/aarch64/plat_helpers.S \ |
| 135 | $(PLAT_COMMON_BASE)/aarch64/plat_arch_config.c \ |
| 136 | $(PLAT_COMMON_BASE)/plat_pm.c \ |
| 137 | $(PLAT_COMMON_BASE)/plat_bl31_setup.c \ |
| 138 | $(MARVELL_COMMON_BASE)/marvell_gicv2.c \ |
| 139 | $(MARVELL_COMMON_BASE)/mrvl_sip_svc.c \ |
| 140 | $(MARVELL_COMMON_BASE)/marvell_ddr_info.c \ |
| 141 | $(BL31_PORTING_SOURCES) \ |
| 142 | $(MARVELL_DRV) \ |
| 143 | $(MARVELL_MOCHI_DRV) \ |
| 144 | $(MARVELL_GIC_SOURCES) |
| 145 | |
| 146 | # Add trace functionality for PM |
| 147 | BL31_SOURCES += $(PLAT_COMMON_BASE)/plat_pm_trace.c |
| 148 | |
Konstantin Porotchkin | 2309961 | 2020-10-12 18:13:07 +0300 | [diff] [blame] | 149 | |
| 150 | ifeq (${MSS_SUPPORT}, 1) |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 151 | # Force builds with BL2 image on a80x0 platforms |
| 152 | ifndef SCP_BL2 |
| 153 | $(error "Error: SCP_BL2 image is mandatory for a8k family") |
| 154 | endif |
| 155 | |
| 156 | # MSS (SCP) build |
| 157 | include $(PLAT_COMMON_BASE)/mss/mss_a8k.mk |
Konstantin Porotchkin | 2309961 | 2020-10-12 18:13:07 +0300 | [diff] [blame] | 158 | endif |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 159 | |
| 160 | # BLE (ROM context execution code, AKA binary extension) |
Konstantin Porotchkin | 01851db | 2018-10-03 14:21:42 +0300 | [diff] [blame] | 161 | BLE_PATH ?= $(PLAT_COMMON_BASE)/ble |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 162 | |
| 163 | include ${BLE_PATH}/ble.mk |
| 164 | $(eval $(call MAKE_BL,e)) |
| 165 | |
Pali Rohár | 06a38e2 | 2020-11-23 19:45:28 +0100 | [diff] [blame] | 166 | clean realclean distclean: mrvl_clean |
| 167 | |
| 168 | .PHONY: mrvl_clean |
Pali Rohár | 6dca2c6 | 2020-10-21 11:50:40 +0200 | [diff] [blame] | 169 | mrvl_clean: |
| 170 | @echo " Doimage CLEAN" |
| 171 | ${Q}${MAKE} PLAT=${PLAT} --no-print-directory -C ${DOIMAGEPATH} clean |
| 172 | |
Pali Rohár | 06a38e2 | 2020-11-23 19:45:28 +0100 | [diff] [blame] | 173 | ${DOIMAGETOOL}: FORCE |
Pali Rohár | 6dca2c6 | 2020-10-21 11:50:40 +0200 | [diff] [blame] | 174 | @$(DOIMAGE_LIBS_CHECK) |
| 175 | ${Q}${MAKE} --no-print-directory -C ${DOIMAGEPATH} |
| 176 | |
Pali Rohár | 4bce4d5 | 2021-01-26 10:44:07 +0100 | [diff] [blame] | 177 | ${BUILD_PLAT}/${FLASH_IMAGE}: ${ROM_BIN_EXT} ${BUILD_PLAT}/${BOOT_IMAGE} ${DOIMAGETOOL} |
Pali Rohár | 7cf48c8 | 2021-01-26 10:44:07 +0100 | [diff] [blame] | 178 | @${ECHO_BLANK_LINE} |
| 179 | @echo "Building flash image" |
| 180 | ${Q}${DOIMAGETOOL} ${DOIMAGE_FLAGS} ${BUILD_PLAT}/${BOOT_IMAGE} ${BUILD_PLAT}/${FLASH_IMAGE} |
| 181 | @${ECHO_BLANK_LINE} |
| 182 | @echo "Built $@ successfully" |
| 183 | @${ECHO_BLANK_LINE} |